<?php
//INCLUDES
include_once '../inc-php/fx-db.php';
include_once '../inc-php/common.php';
include_once '../inc-php/db.php';
/////////////////////

// Si no provenim del formulari corresponent, redireccionem.
if (!$_POST['edform']) { echo "<meta http-equiv=Refresh content=\"0 ; url=../default.php\">"; }

// Si el camp de Ttol no s'ha omplert, s'avisa i s'ofereix tornar enrere (no s'ha pogut realitzar una doble validaci juntament amb
// la data, si la data es valida no es valida el ttol, i si es valida el ttol no es valida la data, aix que s'ha optat per validar
// la data en client, i deixar el ttol per al servidor. No obstant, com el servidor, al tirar enrere, pot deixar la pgina en blanc i
// l'usuari pot no saber com actuar, s'ha optat per avisar del que ha succet per enregistrant igualment l'examen, ja que no tenir
// ttol no provoca cap error, aix s, tot avisant a l'usuari que modifiqui l'examen per a especificar-hi un ttol.
$faltaTitol = "";
if (trim($_POST['titol'])=='') $faltaTitol = "<br><br><font color='red'><b><u>Avs Ttol</u></b></font>: L'Examen s'ha enregistrat per no s'ha especificat cap Ttol; se'n pot especificar un editant l'examen en qesti des del llistat d'examens.";

// Recollim les variables que necessitem
$idAssignatura = $_POST['idAssignatura'];
$numPreguntes = $_POST['numPreguntes'];
$numRespostes = $_POST['numRespostes'];
$titol = $_POST['titol'];
$oficial = $_POST['oficial'];
$public = $_POST['public'];
$dataMaxima = $_POST['dataMaxima'];
$preguntes = "";
$respostes = "";
$solucions = "";
$fotos = "";
$imgtransparent = '--';			//Nom imatge transparent (quan error o foto buida, omplir amb --)

// Si tenim data mxima (10 chars), comencem posant-la en un format de mySQL (yyyy-mm-dd)
if (strlen($dataMaxima) == 10)
{
	// Primen, si ens arriba una data amb barres, la canviem per guions
	$dataMaxima = str_replace("/","-",$dataMaxima); //echo $dataMaxima . "<br>";
	// Posteriorment, la posem en format MySQL
	$dataMaxima = dataDDMMAAAA($dataMaxima);		//echo $dataMaxima . "<br>";
}

// Per a les variables que enmagatzemarem en concatenacions, mirem si s una pregunta, resposta o soluci, i concatenem amb la variable corresponent
// D'igual manera que s'ha validat l'absncia de ttol per s'ha deixat seguir, es validaran els camps de preguntes i respostes si estan buits
$faltaPreguntaInt = 0;
$faltaRespostaInt = 0;

/////////////////////////////////////////// INICI TRACTAMENT FOTOS ////////////////////////////////////////////////////////////////////////////
// Variables per les fotos //////////////////////////////////////////////////////////////////////
$Fotos = ""; 				 	//String on anar guardant els noms per guardar-los a la BD
$success = 0;					//Intents OK
$fail = 0;						//Intents KO
$uploaddir = '../media/fotos/';	//Directori on es guarden les imgs
$imgtransparent = '--';			//Nom imatge transparent (quan error o foto buida, omplir amb --)
/////////////////////////////////////////////////////////////////////////////////////////////////
//var_dump($_FILES);

// Separem les accions segons si estem donant d'alta un examen, o b s una modificaci. Aix ens arriba amb un hidden.
$accio = $_POST['accio'];

if ($accio === 'nou') 
{
	while (list($keyfile, $valuefile) = each($_FILES))
	{
		//echo "\n$keyfile => $valuefile <br>";
		// Si ens arriba un fitxer amb nom, fem l'upload (el propi upload omplir la concatenaci amb el nom del fitxer pujat)
		if($_FILES[$keyfile]['name'])
		{
			upload_imatge($keyfile);
		}
		// Cas contrari, omplim la concatenaci amb "--"
		else
		{
			$Fotos = $Fotos . $imgtransparent . "#";
		}
	}
}	
elseif ($accio === 'editar')
{
	// Creem una variable suma que ens anir comptant quantes vegades repetim el while, aix podem anar mirant els check$i i URLFoto$i
	$suma = 0;
	while (list($keyfile, $valuefile) = each($_FILES))
	{
		$suma++; //echo $suma . "<br>";
		$urlfoto = "URLFoto" . $suma;
		// Si el check de la foto en qesti est seleccionat, en aquesta posici de $textFotos hi haur ara "--" i eliminem la foto antiga,
		// que ens arriba per hidden com a URLFoto$i
	
		// Si ens arriba un fitxer amb nom, fem l'upload (el propi upload omplir la concatenaci amb el nom del fitxer pujat)
		if($_FILES[$keyfile]['name'])
		{
			//echo "<br>Entro 1<br>";
			upload_imatge($keyfile);
			// Esborrem la imatge antiga que hi havia si s que aquesta en substitueix una anterior
			delete_imatge($imgtransparent, $uploaddir, $_POST[$urlfoto]);
		}
		// En cas contrari podem estar en una de les segents opcions:
		// 1- S'ha seleccionat el check d'establir la foto en blanc (posem "--" a la concatenaci de noms de fotos i eliminem la foto que havia)
		// 2- No ens arriba fitxer perque el que hi ha actualment ha de seguir-hi (incls si actualment s "--", ha de seguir sent-ho)
		else
		{
			$check = "CheckFoto" . $suma;
			if ($_POST[$check])
			{
				$Fotos = $Fotos . $imgtransparent . "#";
				delete_imatge($imgtransparent, $uploaddir, $_POST[$urlfoto]);
			}
			else
			{
				$Fotos = $Fotos . $_POST[$urlfoto] . "#";
			}
		}
	}
}
/////////////////////////////////////////// FI TRACTAMENT FOTOS ///////////////////////////////////////////////////////////////////////////////
//echo $Fotos;

while (list($key, $value) = each($_POST))
{
	//echo "\n$key => $value <br>";
	$substring = substr($key, 0, 3);
	switch ($substring)
	{
		case "pre":	$preguntes = $preguntes . $value . "###"; if (trim($value)=='') { $faltaPreguntaInt = 1; } break;
		case "res":	$respostes = $respostes . $value . "###"; if (trim($value)=='') { $faltaRespostaInt = 1; } break;
		case "sol":	$solucions = $solucions . $value . "#"; break;
	}
}
	// Si s'han trobat preguntes o respostes sense contingut, establim el missatge que es mostrar
	$faltaPregunta = "";
	$faltaResposta = "";
	if ($faltaPreguntaInt == 1) $faltaPregunta = "<br><br><font color='red'><b><u>Avs Preguntes</u></b></font>: L'Examen s'ha enregistrat per hi ha preguntes sense contingut; se'n pot especificar un editant l'examen en qesti des del llistat d'examens.";
	if ($faltaRespostaInt == 1) $faltaResposta = "<br><br><font color='red'><b><u>Avs Respostes</u></b></font>: L'Examen s'ha enregistrat per hi ha respostes sense contingut; se'n pot especificar un editant l'examen en qesti des del llistat d'examens.";


// Eliminem les # del final de cada cadena
$preguntes = substr($preguntes, 0, -3);
$respostes = substr($respostes, 0, -3);
$solucions = substr($solucions, 0, -1);
//echo $preguntes . "<br>" . $respostes . "<br>" . $solucions;

// Discernim si estem fent una alta, o una modificaci. Aix ho sabem segons si ens arriba o no un Id d'Examen
if (!$_POST['idExamen'])
{
	// Donem d'alta l'examen.
	insert_examen($idAssignatura, $titol, $oficial, $public, $dataMaxima, $numPreguntes, $numRespostes, $preguntes, $respostes, $solucions, $Fotos);
	$okTitol = "Nou Examen";
	$okText = "Examen afegit correctament." . $faltaTitol . $faltaPregunta . $faltaResposta;
}
else
{
	// Fem la modificaci
	$exa = $_POST['idExamen'];
	examen_modificar($exa, $titol, $public, $dataMaxima, $preguntes, $respostes, $solucions, $Fotos);
	$okTitol = "Examen modificat";
	$okText = "L'Examen s'ha modificat correctament." . $faltaTitol . $faltaPregunta . $faltaResposta;
}

// Presentem en pantalla que el procediment ha tingut xit
$okTornar = "<a href=\"index.php?s=ael\">Tornar</a>";
require ('../confirmacio.php');
?>