<?php
//INCLUDES
include_once 'inc-php/fx-db.php';
include_once 'inc-php/common.php';
include_once 'inc-php/db.php';
/////////////////////

// Si no provenim del formulari corresponent, redireccionem.
if (!$_POST['redform']) { echo "<meta http-equiv=Refresh content=\"0 ; url=default.php\">"; }

// Recollim les variables que necessitem tant si es tracta d'un examen oficial com d'un de seguiment
$idExamen = $_POST['idExamen'];
$idAlumne = $_POST['idAlumne'];
$oficial = $_POST['oficial'];
$numPreguntes = $_POST['numPreguntes'];
//echo "examen: " . $idExamen . "<br>alumne: " . $idAlumne . "<br>oficial: " . $oficial . "<br>numPreguntes: " . $numPreguntes . "<br>" ;
// Concatenem en una variable les respostes que ha fet l'alumne, pel que:
// Segons el nombre de preguntes de l'examen, cerquem les variables dels radiobutton. Si t valor, s la resposta. Cas contrari, 0.
$solucionsAlumne = "";
for ($i = 1; $i < $numPreguntes+1; $i++)
{
	$numeroSolucio = "solucio" . $i; //	echo "<br>" . $numeroSolucio;
	$solucioAlumne = $_POST[$numeroSolucio]; // echo $solucioAlumne . "<br>";
	if ($solucioAlumne > 0) $solucionsAlumne = $solucionsAlumne . $solucioAlumne . "#";
	else $solucionsAlumne = $solucionsAlumne . "0#"; // echo "solucions per ara: " . $solucions;
}
// Eliminem la # del final de la cadena de respostes
$solucionsAlumne = substr($solucionsAlumne, 0, -1);

// Un cop tenim les solucions de l'alumne, demanem al sistema les solucions de l'examen
// (no les passem com a hidden des del formulari per assegurar que cap alumne pot descobrir-les)
$solucionsExamen = examen_solucions($idExamen);
$solucionsExamen = $solucionsExamen[0]['Solucions'];

// Comparem els 2 strings (solucionsAlumne i solucionsExamen) en format array per calcular la nota
$solucionsAlumneExplode = explode("#", $solucionsAlumne);
$solucionsExamen = explode("#", $solucionsExamen);

//var_dump($solucionsAlumne); var_dump($solucionsExamen);

$respostesOK = 0;
$respostesKO = 0;
for ($i = 0; $i < $numPreguntes; $i++)
{
	// echo $solucionsAlumne[$i] . " vs " . $solucionsExamen[$i] . "<br>";
	if ($solucionsAlumneExplode[$i] == $solucionsExamen[$i]) $respostesOK += 1;
	else $respostesKO += 1;
}
$nota = round((($respostesOK/$numPreguntes)*10) * 100) / 100;

// Si s un examen de seguiment
if ($oficial == 0)
{
	$okTitol = "Correcci d'Examen de seguiment";
	$okText = "Respostes correctes: " . $respostesOK . "<br>Respostes incorrectes: " . $respostesKO . "<br><br>Nota = " . $nota;
	$okTornar = "<a href=\"index.php\">Tornar</a>";
}
// Si s un examen oficial, enregistrem a "respostes_alumne" les respostes i a "examen" l'identificador de l'alumne i la seva nota
elseif ($oficial == 1)
{
	insert_respostesalumne($idExamen, $idAlumne, $solucionsAlumne);
	$alumne_i_Nota = $idAlumne . " - " . $nota . "#";
	examen_intro_nota($idExamen, $alumne_i_Nota);
	$okTitol = "Examen oficial";
	$okText = "Examen enregistrat correctament. Quan les notes estiguin disponibles es podran consultar des de la taula d'examens.";	
	$okTornar = "<a href=\"index.php\">Tornar</a>";
}

// Presentem en pantalla que el procediment ha tingut xit
require ('confirmacio.php');
?>